---
type: api
title: Get data stream settings
description: Get setting information for one or more data streams.
url: https://www.elastic.co/docs/api/doc/elasticsearch-serverless/operation/operation-indices-get-data-stream-settings
resource: https://www.elastic.co/docs/api/doc/elasticsearch-serverless/operation/operation-indices-get-data-stream-settings
products:
  - Elasticsearch Serverless
---

# Get data stream settings

Authentication: required

## Paths

- `GET` `/_data_stream/{name}/_settings`

#### Path parameters

- `name` (union string | string[]) — required
  A comma-separated list of data streams or data stream patterns. Supports wildcards (`*`).

## Description

Get setting information for one or more data streams.

## Required privileges

- Index privileges: `view_index_metadata`

## Query string parameters

- `master_timeout` (union oneOf · default: 30s) — optional
  The period to wait for a connection to the master node. If no response is
received before the timeout expires, the request fails and returns an
error.
  Values: `-1`, `0`

## Response

`application/json`

- `data_streams` (object[])
  - `name` (string)
    The name of the data stream.
  - `settings` (object)
    The settings specific to this data stream
    - `index` (object) — recursive
      Same fields as `settings` in `data_streams`
    - `mode` (string)
    - `routing_path` (union string | string[])
    - `soft_deletes` (object)
      - `enabled` (boolean · default: true)
        Indicates whether soft deletes are enabled on the index.
      - `retention_lease` (object)
        The maximum period to retain a shard history retention lease before it is considered expired.
Shard history retention leases ensure that soft deletes are retained during merges on the Lucene
index. If a soft delete is merged away before it can be replicated to a follower the following
process will fail due to incomplete history on the leader.
        - `period` (union oneOf)
          Values: `-1`, `0`
    - `sort` (object)
      - `field` (union oneOf)
        One of: `string[]` or `string`
      - `order` (union enum | enum[])
        

Supported values include: `asc` (or `ASC`), `desc` (or `DESC`)
        Values: `asc`, `ASC`, `desc`, `DESC`
      - `mode` (union enum | enum[])
        

Supported values include: `min` (or `MIN`), `max` (or `MAX`)
        Values: `min`, `MIN`, `max`, `MAX`
      - `missing` (union enum | enum[])
        

Supported values include: `_last`, `_first`
        Values: `_last`, `_first`
    - `number_of_routing_shards` (number)
    - `check_on_startup` (enum · default: false)
      Values: `true`, `false`, `checksum`
    - `codec` (string · default: LZ4)
    - `routing_partition_size` (number | string · default: 1)
    - `load_fixed_bitset_filters_eagerly` (boolean · default: true)
    - `hidden` (boolean | string · default: false)
    - `auto_expand_replicas` (union string · default: false) — nullable
    - `merge` (object)
      - `scheduler` (object)
        - `max_thread_count` (number | string)
        - `max_merge_count` (number | string)
    - `search` (object)
      - `idle` (object)
        - `after` (union oneOf · default: 30s)
          Values: `-1`, `0`
      - `slowlog` (object)
        - `level` (string)
        - `source` (number)
        - `reformat` (boolean)
        - `threshold` (object)
          - `query` (object)
            - `warn` (union oneOf)
              Values: `-1`, `0`
            - `info` (union oneOf)
              Values: `-1`, `0`
            - `debug` (union oneOf)
              Values: `-1`, `0`
            - `trace` (union oneOf)
              Values: `-1`, `0`
          - `fetch` (object)
            - `warn` (union oneOf)
              Values: `-1`, `0`
            - `info` (union oneOf)
              Values: `-1`, `0`
            - `debug` (union oneOf)
              Values: `-1`, `0`
            - `trace` (union oneOf)
              Values: `-1`, `0`
    - `refresh_interval` (union oneOf · default: 1s)
      Values: `-1`, `0`
    - `max_result_window` (number | string · default: 10000)
    - `max_inner_result_window` (number · default: 100)
    - `max_rescore_window` (number · default: 10000)
    - `max_docvalue_fields_search` (number · default: 100)
    - `max_script_fields` (number · default: 32)
    - `max_ngram_diff` (number · default: 1)
    - `max_shingle_diff` (number · default: 3)
    - `blocks` (object)
      - `read_only` (boolean | string)
      - `read_only_allow_delete` (boolean | string)
      - `read` (boolean | string)
      - `write` (boolean | string)
      - `metadata` (boolean | string)
    - `max_refresh_listeners` (number)
    - `analyze` (object)
      Settings to define analyzers, tokenizers, token filters and character filters.
Refer to the linked documentation for step-by-step examples of updating analyzers on existing indices.
      - `max_token_count` (number | string · default: 10000)
    - `highlight` (object)
      - `max_analyzed_offset` (number · default: 1000000)
    - `max_terms_count` (number · default: 65536)
    - `max_regex_length` (number · default: 1000)
    - `routing` (object)
      - `allocation` (object)
        - `enable` (enum)
          Values: `all`, `primaries`, `new_primaries`, `none`
        - `include` (object)
          - `_tier_preference` (string)
          - `_id` (string)
        - `require` (object)
          Assign the index to a node whose attribute has all of the given values.
Each key is a node attribute: one of the built-in attributes `_name`, `_host_ip`, `_publish_ip`, `_ip`, `_host`, `_id` and `_tier`, or a custom node attribute.
Each value is a comma-separated string or an array of strings, and can use wildcards.
        - `initial_recovery` (object)
          - `_id` (string)
        - `disk` (object)
          - `threshold_enabled` (boolean | string)
      - `rebalance` (object)
        - `enable` (enum)
          Values: `all`, `primaries`, `replicas`, `none`
    - `unassigned` (object)
      - `node_left` (object)
        - `delayed_timeout` (union oneOf · default: 1m)
          The amount of time to wait for a node that has left before assuming its
shards are permanently missing and starting to allocate replacement replicas.
          Values: `-1`, `0`
    - `gc_deletes` (union oneOf · default: 60s)
      Values: `-1`, `0`
    - `default_pipeline` (string · default: _none)
    - `final_pipeline` (string · default: _none)
    - `lifecycle` (object)
      - `name` (string)
        The name of the policy to use to manage the index. For information about how Elasticsearch applies policy changes, see Policy updates.
      - `indexing_complete` (boolean | string · default: false)
        Indicates whether or not the index has been rolled over. Automatically set to true when ILM completes the rollover action.
You can explicitly set it to skip rollover.
      - `origination_date` (number · default: 0)
        If specified, this is the timestamp used to calculate the index age for its phase transitions. Use this setting
if you create a new index that contains old data and want to use the original creation date to calculate the index
age. Specified as a Unix epoch value in milliseconds.
      - `parse_origination_date` (boolean)
        Set to true to parse the origination date from the index name. This origination date is used to calculate the index age
for its phase transitions. The index name must match the pattern ^.*-{date_format}-\\d+, where the date_format is
yyyy.MM.dd and the trailing digits are optional. An index that was rolled over would normally match the full format,
for example logs-2016.10.31-000002). If the index name doesn’t match the pattern, index creation fails.
      - `step` (object)
        - `wait_time_threshold` (union oneOf)
          Time to wait for the cluster to resolve allocation issues during an ILM shrink action. Must be greater than 1h (1 hour).
See Shard allocation for shrink.
          Values: `-1`, `0`
      - `rollover_alias` (string)
        The index alias to update when the index rolls over. Specify when using a policy that contains a rollover action.
When the index rolls over, the alias is updated to reflect that the index is no longer the write index. For more
information about rolling indices, see Rollover.
      - `prefer_ilm` (boolean | string · default: true)
        Preference for the system that manages a data stream backing index (preferring ILM when both ILM and DLM are
applicable for an index).
    - `provided_name` (string)
    - `creation_date` (union oneOf)
      One of: `number` or `string`
    - `creation_date_string` (union oneOf)
      One of: `string` or `number`
    - `uuid` (string)
    - `version` (object)
      - `created` (string)
      - `created_string` (string)
    - `verified_before_close` (boolean | string)
    - `format` (number | string)
    - `max_slices_per_scroll` (number)
    - `translog` (object)
      - `sync_interval` (union oneOf · default: 5s)
        How often the translog is fsynced to disk and committed, regardless of write operations.
Values less than 100ms are not allowed.
        Values: `-1`, `0`
      - `durability` (enum · default: string)
        Whether or not to `fsync` and commit the translog after every index, delete, update, or bulk request.

Supported values include:
  - `request` (or `REQUEST`): (default) fsync and commit after every request. In the event of hardware failure, all acknowledged writes
will already have been committed to disk.
  - `async` (or `ASYNC`): fsync and commit in the background every sync_interval. In the event of a failure, all acknowledged writes
since the last automatic commit will be discarded.
        Values: `request`, `REQUEST`, `async`, `ASYNC`
      - `flush_threshold_size` (number | string · default: 512mb)
        The translog stores all operations that are not yet safely persisted in Lucene (i.e., are not
part of a Lucene commit point). Although these operations are available for reads, they will need
to be replayed if the shard was stopped and had to be recovered. This setting controls the
maximum total size of these operations, to prevent recoveries from taking too long. Once the
maximum size has been reached a flush will happen, generating a new Lucene commit point.
      - `retention` (object)
        - `size` (number | string · default: 512mb)
          This controls the total size of translog files to keep for each shard. Keeping more translog files increases
the chance of performing an operation based sync when recovering a replica. If the translog files are not
sufficient, replica recovery will fall back to a file based sync. This setting is ignored, and should not be
set, if soft deletes are enabled. Soft deletes are enabled by default in indices created in Elasticsearch
versions 7.0.0 and later.
        - `age` (union oneOf · default: 12h)
          This controls the maximum duration for which translog files are kept by each shard. Keeping more
translog files increases the chance of performing an operation based sync when recovering replicas. If
the translog files are not sufficient, replica recovery will fall back to a file based sync. This setting
is ignored, and should not be set, if soft deletes are enabled. Soft deletes are enabled by default in
indices created in Elasticsearch versions 7.0.0 and later.
          Values: `-1`, `0`
    - `query_string` (object)
      - `lenient` (boolean | string)
    - `priority` (number | string)
    - `top_metrics_max_size` (number)
    - `analysis` (object)
      - `analyzer` (map string to oneOf)
        Map values (union oneOf)
        One of:
        - **type: custom** (`type: custom`)
          - `type` (enum)
            Values: `custom`
          - `char_filter` (union string | string[])
          - `filter` (union string | string[])
          - `position_increment_gap` (number)
          - `position_offset_gap` (number)
          - `tokenizer` (string)
        - **type: fingerprint** (`type: fingerprint`)
          - `type` (enum)
            Values: `fingerprint`
          - `version` (string) — deprecated
          - `max_output_size` (number · default: 255)
            The maximum token size to emit. Tokens larger than this size will be discarded.
Defaults to `255`
          - `separator` (string)
            The character to use to concatenate the terms.
Defaults to a space.
          - `stopwords` (union oneOf · default: _none_)
            A pre-defined stop words list like `_english_` or an array containing a list of stop words.
Defaults to `_none_`.
            Values: `_arabic_`, `_armenian_`, `_basque_`, `_bengali_`, `_brazilian_`, `_bulgarian_`, `_catalan_`, `_cjk_`, `_czech_`, `_danish_`, `_dutch_`, `_english_`, `_estonian_`, `_finnish_`, `_french_`, `_galician_`, `_german_`, `_greek_`, `_hindi_`, `_hungarian_`, `_indonesian_`, `_irish_`, `_italian_`, `_latvian_`, `_lithuanian_`, `_norwegian_`, `_persian_`, `_portuguese_`, `_romanian_`, `_russian_`, `_serbian_`, `_sorani_`, `_spanish_`, `_swedish_`, `_thai_`, `_turkish_`, `_none_`
          - `stopwords_path` (string)
            The path to a file containing stop words.
        - **type: keyword** (`type: keyword`)
          - `type` (enum)
            Values: `keyword`
          - `version` (string) — deprecated
        - **type: nori** (`type: nori`)
          - `type` (enum)
            Values: `nori`
          - `version` (string) — deprecated
          - `decompound_mode` (enum)
            Values: `discard`, `none`, `mixed`
          - `stoptags` (string[])
          - `user_dictionary` (string)
        - **type: pattern** (`type: pattern`)
          - `type` (enum)
            Values: `pattern`
          - `version` (string) — deprecated
          - `flags` (string)
            Java regular expression flags. Flags should be pipe-separated, eg "CASE_INSENSITIVE|COMMENTS".
          - `lowercase` (boolean · default: true)
            Should terms be lowercased or not.
Defaults to `true`.
          - `pattern` (string · default: \W+)
            A Java regular expression.
Defaults to `\W+`.
          - `stopwords` (union oneOf · default: _none_)
            A pre-defined stop words list like `_english_` or an array containing a list of stop words.
Defaults to `_none_`.
            Values: `_arabic_`, `_armenian_`, `_basque_`, `_bengali_`, `_brazilian_`, `_bulgarian_`, `_catalan_`, `_cjk_`, `_czech_`, `_danish_`, `_dutch_`, `_english_`, `_estonian_`, `_finnish_`, `_french_`, `_galician_`, `_german_`, `_greek_`, `_hindi_`, `_hungarian_`, `_indonesian_`, `_irish_`, `_italian_`, `_latvian_`, `_lithuanian_`, `_norwegian_`, `_persian_`, `_portuguese_`, `_romanian_`, `_russian_`, `_serbian_`, `_sorani_`, `_spanish_`, `_swedish_`, `_thai_`, `_turkish_`, `_none_`
          - `stopwords_path` (string)
            The path to a file containing stop words.
        - **type: simple** (`type: simple`)
          - `type` (enum)
            Values: `simple`
          - `version` (string) — deprecated
        - **type: standard** (`type: standard`)
          - `type` (enum)
            Values: `standard`
          - `max_token_length` (number · default: 255)
            The maximum token length. If a token is seen that exceeds this length then it is split at `max_token_length` intervals.
Defaults to `255`.
          - `stopwords` (union oneOf · default: _none_)
            A pre-defined stop words list like `_english_` or an array containing a list of stop words.
Defaults to `_none_`.
            Values: `_arabic_`, `_armenian_`, `_basque_`, `_bengali_`, `_brazilian_`, `_bulgarian_`, `_catalan_`, `_cjk_`, `_czech_`, `_danish_`, `_dutch_`, `_english_`, `_estonian_`, `_finnish_`, `_french_`, `_galician_`, `_german_`, `_greek_`, `_hindi_`, `_hungarian_`, `_indonesian_`, `_irish_`, `_italian_`, `_latvian_`, `_lithuanian_`, `_norwegian_`, `_persian_`, `_portuguese_`, `_romanian_`, `_russian_`, `_serbian_`, `_sorani_`, `_spanish_`, `_swedish_`, `_thai_`, `_turkish_`, `_none_`
          - `stopwords_path` (string)
            The path to a file containing stop words.
        - **type: stop** (`type: stop`)
          - `type` (enum)
            Values: `stop`
          - `version` (string) — deprecated
          - `stopwords` (union oneOf · default: _none_)
            A pre-defined stop words list like `_english_` or an array containing a list of stop words.
Defaults to `_none_`.
            Values: `_arabic_`, `_armenian_`, `_basque_`, `_bengali_`, `_brazilian_`, `_bulgarian_`, `_catalan_`, `_cjk_`, `_czech_`, `_danish_`, `_dutch_`, `_english_`, `_estonian_`, `_finnish_`, `_french_`, `_galician_`, `_german_`, `_greek_`, `_hindi_`, `_hungarian_`, `_indonesian_`, `_irish_`, `_italian_`, `_latvian_`, `_lithuanian_`, `_norwegian_`, `_persian_`, `_portuguese_`, `_romanian_`, `_russian_`, `_serbian_`, `_sorani_`, `_spanish_`, `_swedish_`, `_thai_`, `_turkish_`, `_none_`
          - `stopwords_path` (string)
            The path to a file containing stop words.
        - **type: whitespace** (`type: whitespace`)
          - `type` (enum)
            Values: `whitespace`
          - `version` (string) — deprecated
        - **type: icu_analyzer** (`type: icu_analyzer`)
          - `type` (enum)
            Values: `icu_analyzer`
          - `method` (enum)
            Values: `nfc`, `nfkc`, `nfkc_cf`
          - `mode` (enum)
            Values: `decompose`, `compose`
        - **type: kuromoji** (`type: kuromoji`)
          - `type` (enum)
            Values: `kuromoji`
          - `mode` (enum)
            Values: `normal`, `search`, `extended`
          - `user_dictionary` (string)
        - **type: snowball** (`type: snowball`)
          - `type` (enum)
            Values: `snowball`
          - `version` (string) — deprecated
          - `language` (enum)
            Values: `Arabic`, `Armenian`, `Basque`, `Catalan`, `Danish`, `Dutch`, `English`, `Estonian`, `Finnish`, `French`, `German`, `German2`, `Hungarian`, `Italian`, `Irish`, `Kp`, `Lithuanian`, `Lovins`, `Norwegian`, `Porter`, `Portuguese`, `Romanian`, `Russian`, `Serbian`, `Spanish`, `Swedish`, `Turkish`
          - `stopwords` (union oneOf)
            Values: `_arabic_`, `_armenian_`, `_basque_`, `_bengali_`, `_brazilian_`, `_bulgarian_`, `_catalan_`, `_cjk_`, `_czech_`, `_danish_`, `_dutch_`, `_english_`, `_estonian_`, `_finnish_`, `_french_`, `_galician_`, `_german_`, `_greek_`, `_hindi_`, `_hungarian_`, `_indonesian_`, `_irish_`, `_italian_`, `_latvian_`, `_lithuanian_`, `_norwegian_`, `_persian_`, `_portuguese_`, `_romanian_`, `_russian_`, `_serbian_`, `_sorani_`, `_spanish_`, `_swedish_`, `_thai_`, `_turkish_`, `_none_`
        - **type: arabic** (`type: arabic`)
          - `type` (enum)
            Values: `arabic`
          - `stopwords` (union oneOf)
            Values: `_arabic_`, `_armenian_`, `_basque_`, `_bengali_`, `_brazilian_`, `_bulgarian_`, `_catalan_`, `_cjk_`, `_czech_`, `_danish_`, `_dutch_`, `_english_`, `_estonian_`, `_finnish_`, `_french_`, `_galician_`, `_german_`, `_greek_`, `_hindi_`, `_hungarian_`, `_indonesian_`, `_irish_`, `_italian_`, `_latvian_`, `_lithuanian_`, `_norwegian_`, `_persian_`, `_portuguese_`, `_romanian_`, `_russian_`, `_serbian_`, `_sorani_`, `_spanish_`, `_swedish_`, `_thai_`, `_turkish_`, `_none_`
          - `stopwords_path` (string)
          - `stem_exclusion` (string[])
        - **type: armenian** (`type: armenian`)
          - `type` (enum)
            Values: `armenian`
          - `stopwords` (union oneOf)
            Values: `_arabic_`, `_armenian_`, `_basque_`, `_bengali_`, `_brazilian_`, `_bulgarian_`, `_catalan_`, `_cjk_`, `_czech_`, `_danish_`, `_dutch_`, `_english_`, `_estonian_`, `_finnish_`, `_french_`, `_galician_`, `_german_`, `_greek_`, `_hindi_`, `_hungarian_`, `_indonesian_`, `_irish_`, `_italian_`, `_latvian_`, `_lithuanian_`, `_norwegian_`, `_persian_`, `_portuguese_`, `_romanian_`, `_russian_`, `_serbian_`, `_sorani_`, `_spanish_`, `_swedish_`, `_thai_`, `_turkish_`, `_none_`
          - `stopwords_path` (string)
          - `stem_exclusion` (string[])
        - **type: basque** (`type: basque`)
          - `type` (enum)
            Values: `basque`
          - `stopwords` (union oneOf)
            Values: `_arabic_`, `_armenian_`, `_basque_`, `_bengali_`, `_brazilian_`, `_bulgarian_`, `_catalan_`, `_cjk_`, `_czech_`, `_danish_`, `_dutch_`, `_english_`, `_estonian_`, `_finnish_`, `_french_`, `_galician_`, `_german_`, `_greek_`, `_hindi_`, `_hungarian_`, `_indonesian_`, `_irish_`, `_italian_`, `_latvian_`, `_lithuanian_`, `_norwegian_`, `_persian_`, `_portuguese_`, `_romanian_`, `_russian_`, `_serbian_`, `_sorani_`, `_spanish_`, `_swedish_`, `_thai_`, `_turkish_`, `_none_`
          - `stopwords_path` (string)
          - `stem_exclusion` (string[])
        - **type: bengali** (`type: bengali`)
          - `type` (enum)
            Values: `bengali`
          - `stopwords` (union oneOf)
            Values: `_arabic_`, `_armenian_`, `_basque_`, `_bengali_`, `_brazilian_`, `_bulgarian_`, `_catalan_`, `_cjk_`, `_czech_`, `_danish_`, `_dutch_`, `_english_`, `_estonian_`, `_finnish_`, `_french_`, `_galician_`, `_german_`, `_greek_`, `_hindi_`, `_hungarian_`, `_indonesian_`, `_irish_`, `_italian_`, `_latvian_`, `_lithuanian_`, `_norwegian_`, `_persian_`, `_portuguese_`, `_romanian_`, `_russian_`, `_serbian_`, `_sorani_`, `_spanish_`, `_swedish_`, `_thai_`, `_turkish_`, `_none_`
          - `stopwords_path` (string)
          - `stem_exclusion` (string[])
        - **type: brazilian** (`type: brazilian`)
          - `type` (enum)
            Values: `brazilian`
          - `stopwords` (union oneOf)
            Values: `_arabic_`, `_armenian_`, `_basque_`, `_bengali_`, `_brazilian_`, `_bulgarian_`, `_catalan_`, `_cjk_`, `_czech_`, `_danish_`, `_dutch_`, `_english_`, `_estonian_`, `_finnish_`, `_french_`, `_galician_`, `_german_`, `_greek_`, `_hindi_`, `_hungarian_`, `_indonesian_`, `_irish_`, `_italian_`, `_latvian_`, `_lithuanian_`, `_norwegian_`, `_persian_`, `_portuguese_`, `_romanian_`, `_russian_`, `_serbian_`, `_sorani_`, `_spanish_`, `_swedish_`, `_thai_`, `_turkish_`, `_none_`
          - `stopwords_path` (string)
        - **type: bulgarian** (`type: bulgarian`)
          - `type` (enum)
            Values: `bulgarian`
          - `stopwords` (union oneOf)
            Values: `_arabic_`, `_armenian_`, `_basque_`, `_bengali_`, `_brazilian_`, `_bulgarian_`, `_catalan_`, `_cjk_`, `_czech_`, `_danish_`, `_dutch_`, `_english_`, `_estonian_`, `_finnish_`, `_french_`, `_galician_`, `_german_`, `_greek_`, `_hindi_`, `_hungarian_`, `_indonesian_`, `_irish_`, `_italian_`, `_latvian_`, `_lithuanian_`, `_norwegian_`, `_persian_`, `_portuguese_`, `_romanian_`, `_russian_`, `_serbian_`, `_sorani_`, `_spanish_`, `_swedish_`, `_thai_`, `_turkish_`, `_none_`
          - `stopwords_path` (string)
          - `stem_exclusion` (string[])
        - **type: catalan** (`type: catalan`)
          - `type` (enum)
            Values: `catalan`
          - `stopwords` (union oneOf)
            Values: `_arabic_`, `_armenian_`, `_basque_`, `_bengali_`, `_brazilian_`, `_bulgarian_`, `_catalan_`, `_cjk_`, `_czech_`, `_danish_`, `_dutch_`, `_english_`, `_estonian_`, `_finnish_`, `_french_`, `_galician_`, `_german_`, `_greek_`, `_hindi_`, `_hungarian_`, `_indonesian_`, `_irish_`, `_italian_`, `_latvian_`, `_lithuanian_`, `_norwegian_`, `_persian_`, `_portuguese_`, `_romanian_`, `_russian_`, `_serbian_`, `_sorani_`, `_spanish_`, `_swedish_`, `_thai_`, `_turkish_`, `_none_`
          - `stopwords_path` (string)
          - `stem_exclusion` (string[])
        - **type: chinese** (`type: chinese`)
          - `type` (enum)
            Values: `chinese`
          - `stopwords` (union oneOf)
            Values: `_arabic_`, `_armenian_`, `_basque_`, `_bengali_`, `_brazilian_`, `_bulgarian_`, `_catalan_`, `_cjk_`, `_czech_`, `_danish_`, `_dutch_`, `_english_`, `_estonian_`, `_finnish_`, `_french_`, `_galician_`, `_german_`, `_greek_`, `_hindi_`, `_hungarian_`, `_indonesian_`, `_irish_`, `_italian_`, `_latvian_`, `_lithuanian_`, `_norwegian_`, `_persian_`, `_portuguese_`, `_romanian_`, `_russian_`, `_serbian_`, `_sorani_`, `_spanish_`, `_swedish_`, `_thai_`, `_turkish_`, `_none_`
          - `stopwords_path` (string)
        - **type: cjk** (`type: cjk`)
          - `type` (enum)
            Values: `cjk`
          - `stopwords` (union oneOf)
            Values: `_arabic_`, `_armenian_`, `_basque_`, `_bengali_`, `_brazilian_`, `_bulgarian_`, `_catalan_`, `_cjk_`, `_czech_`, `_danish_`, `_dutch_`, `_english_`, `_estonian_`, `_finnish_`, `_french_`, `_galician_`, `_german_`, `_greek_`, `_hindi_`, `_hungarian_`, `_indonesian_`, `_irish_`, `_italian_`, `_latvian_`, `_lithuanian_`, `_norwegian_`, `_persian_`, `_portuguese_`, `_romanian_`, `_russian_`, `_serbian_`, `_sorani_`, `_spanish_`, `_swedish_`, `_thai_`, `_turkish_`, `_none_`
          - `stopwords_path` (string)
        - **type: czech** (`type: czech`)
          - `type` (enum)
            Values: `czech`
          - `stopwords` (union oneOf)
            Values: `_arabic_`, `_armenian_`, `_basque_`, `_bengali_`, `_brazilian_`, `_bulgarian_`, `_catalan_`, `_cjk_`, `_czech_`, `_danish_`, `_dutch_`, `_english_`, `_estonian_`, `_finnish_`, `_french_`, `_galician_`, `_german_`, `_greek_`, `_hindi_`, `_hungarian_`, `_indonesian_`, `_irish_`, `_italian_`, `_latvian_`, `_lithuanian_`, `_norwegian_`, `_persian_`, `_portuguese_`, `_romanian_`, `_russian_`, `_serbian_`, `_sorani_`, `_spanish_`, `_swedish_`, `_thai_`, `_turkish_`, `_none_`
          - `stopwords_path` (string)
          - `stem_exclusion` (string[])
        - **type: danish** (`type: danish`)
          - `type` (enum)
            Values: `danish`
          - `stopwords` (union oneOf)
            Values: `_arabic_`, `_armenian_`, `_basque_`, `_bengali_`, `_brazilian_`, `_bulgarian_`, `_catalan_`, `_cjk_`, `_czech_`, `_danish_`, `_dutch_`, `_english_`, `_estonian_`, `_finnish_`, `_french_`, `_galician_`, `_german_`, `_greek_`, `_hindi_`, `_hungarian_`, `_indonesian_`, `_irish_`, `_italian_`, `_latvian_`, `_lithuanian_`, `_norwegian_`, `_persian_`, `_portuguese_`, `_romanian_`, `_russian_`, `_serbian_`, `_sorani_`, `_spanish_`, `_swedish_`, `_thai_`, `_turkish_`, `_none_`
          - `stopwords_path` (string)
        - **type: dutch** (`type: dutch`)
          - `type` (enum)
            Values: `dutch`
          - `stopwords` (union oneOf)
            Values: `_arabic_`, `_armenian_`, `_basque_`, `_bengali_`, `_brazilian_`, `_bulgarian_`, `_catalan_`, `_cjk_`, `_czech_`, `_danish_`, `_dutch_`, `_english_`, `_estonian_`, `_finnish_`, `_french_`, `_galician_`, `_german_`, `_greek_`, `_hindi_`, `_hungarian_`, `_indonesian_`, `_irish_`, `_italian_`, `_latvian_`, `_lithuanian_`, `_norwegian_`, `_persian_`, `_portuguese_`, `_romanian_`, `_russian_`, `_serbian_`, `_sorani_`, `_spanish_`, `_swedish_`, `_thai_`, `_turkish_`, `_none_`
          - `stopwords_path` (string)
          - `stem_exclusion` (string[])
        - **type: english** (`type: english`)
          - `type` (enum)
            Values: `english`
          - `stopwords` (union oneOf)
            Values: `_arabic_`, `_armenian_`, `_basque_`, `_bengali_`, `_brazilian_`, `_bulgarian_`, `_catalan_`, `_cjk_`, `_czech_`, `_danish_`, `_dutch_`, `_english_`, `_estonian_`, `_finnish_`, `_french_`, `_galician_`, `_german_`, `_greek_`, `_hindi_`, `_hungarian_`, `_indonesian_`, `_irish_`, `_italian_`, `_latvian_`, `_lithuanian_`, `_norwegian_`, `_persian_`, `_portuguese_`, `_romanian_`, `_russian_`, `_serbian_`, `_sorani_`, `_spanish_`, `_swedish_`, `_thai_`, `_turkish_`, `_none_`
          - `stopwords_path` (string)
          - `stem_exclusion` (string[])
        - **type: estonian** (`type: estonian`)
          - `type` (enum)
            Values: `estonian`
          - `stopwords` (union oneOf)
            Values: `_arabic_`, `_armenian_`, `_basque_`, `_bengali_`, `_brazilian_`, `_bulgarian_`, `_catalan_`, `_cjk_`, `_czech_`, `_danish_`, `_dutch_`, `_english_`, `_estonian_`, `_finnish_`, `_french_`, `_galician_`, `_german_`, `_greek_`, `_hindi_`, `_hungarian_`, `_indonesian_`, `_irish_`, `_italian_`, `_latvian_`, `_lithuanian_`, `_norwegian_`, `_persian_`, `_portuguese_`, `_romanian_`, `_russian_`, `_serbian_`, `_sorani_`, `_spanish_`, `_swedish_`, `_thai_`, `_turkish_`, `_none_`
          - `stopwords_path` (string)
        - **type: finnish** (`type: finnish`)
          - `type` (enum)
            Values: `finnish`
          - `stopwords` (union oneOf)
            Values: `_arabic_`, `_armenian_`, `_basque_`, `_bengali_`, `_brazilian_`, `_bulgarian_`, `_catalan_`, `_cjk_`, `_czech_`, `_danish_`, `_dutch_`, `_english_`, `_estonian_`, `_finnish_`, `_french_`, `_galician_`, `_german_`, `_greek_`, `_hindi_`, `_hungarian_`, `_indonesian_`, `_irish_`, `_italian_`, `_latvian_`, `_lithuanian_`, `_norwegian_`, `_persian_`, `_portuguese_`, `_romanian_`, `_russian_`, `_serbian_`, `_sorani_`, `_spanish_`, `_swedish_`, `_thai_`, `_turkish_`, `_none_`
          - `stopwords_path` (string)
          - `stem_exclusion` (string[])
        - **type: french** (`type: french`)
          - `type` (enum)
            Values: `french`
          - `stopwords` (union oneOf)
            Values: `_arabic_`, `_armenian_`, `_basque_`, `_bengali_`, `_brazilian_`, `_bulgarian_`, `_catalan_`, `_cjk_`, `_czech_`, `_danish_`, `_dutch_`, `_english_`, `_estonian_`, `_finnish_`, `_french_`, `_galician_`, `_german_`, `_greek_`, `_hindi_`, `_hungarian_`, `_indonesian_`, `_irish_`, `_italian_`, `_latvian_`, `_lithuanian_`, `_norwegian_`, `_persian_`, `_portuguese_`, `_romanian_`, `_russian_`, `_serbian_`, `_sorani_`, `_spanish_`, `_swedish_`, `_thai_`, `_turkish_`, `_none_`
          - `stopwords_path` (string)
          - `stem_exclusion` (string[])
        - **type: galician** (`type: galician`)
          - `type` (enum)
            Values: `galician`
          - `stopwords` (union oneOf)
            Values: `_arabic_`, `_armenian_`, `_basque_`, `_bengali_`, `_brazilian_`, `_bulgarian_`, `_catalan_`, `_cjk_`, `_czech_`, `_danish_`, `_dutch_`, `_english_`, `_estonian_`, `_finnish_`, `_french_`, `_galician_`, `_german_`, `_greek_`, `_hindi_`, `_hungarian_`, `_indonesian_`, `_irish_`, `_italian_`, `_latvian_`, `_lithuanian_`, `_norwegian_`, `_persian_`, `_portuguese_`, `_romanian_`, `_russian_`, `_serbian_`, `_sorani_`, `_spanish_`, `_swedish_`, `_thai_`, `_turkish_`, `_none_`
          - `stopwords_path` (string)
          - `stem_exclusion` (string[])
        - **type: german** (`type: german`)
          - `type` (enum)
            Values: `german`
          - `stopwords` (union oneOf)
            Values: `_arabic_`, `_armenian_`, `_basque_`, `_bengali_`, `_brazilian_`, `_bulgarian_`, `_catalan_`, `_cjk_`, `_czech_`, `_danish_`, `_dutch_`, `_english_`, `_estonian_`, `_finnish_`, `_french_`, `_galician_`, `_german_`, `_greek_`, `_hindi_`, `_hungarian_`, `_indonesian_`, `_irish_`, `_italian_`, `_latvian_`, `_lithuanian_`, `_norwegian_`, `_persian_`, `_portuguese_`, `_romanian_`, `_russian_`, `_serbian_`, `_sorani_`, `_spanish_`, `_swedish_`, `_thai_`, `_turkish_`, `_none_`
          - `stopwords_path` (string)
          - `stem_exclusion` (string[])
        - **type: greek** (`type: greek`)
          - `type` (enum)
            Values: `greek`
          - `stopwords` (union oneOf)
            Values: `_arabic_`, `_armenian_`, `_basque_`, `_bengali_`, `_brazilian_`, `_bulgarian_`, `_catalan_`, `_cjk_`, `_czech_`, `_danish_`, `_dutch_`, `_english_`, `_estonian_`, `_finnish_`, `_french_`, `_galician_`, `_german_`, `_greek_`, `_hindi_`, `_hungarian_`, `_indonesian_`, `_irish_`, `_italian_`, `_latvian_`, `_lithuanian_`, `_norwegian_`, `_persian_`, `_portuguese_`, `_romanian_`, `_russian_`, `_serbian_`, `_sorani_`, `_spanish_`, `_swedish_`, `_thai_`, `_turkish_`, `_none_`
          - `stopwords_path` (string)
        - **type: hindi** (`type: hindi`)
          - `type` (enum)
            Values: `hindi`
          - `stopwords` (union oneOf)
            Values: `_arabic_`, `_armenian_`, `_basque_`, `_bengali_`, `_brazilian_`, `_bulgarian_`, `_catalan_`, `_cjk_`, `_czech_`, `_danish_`, `_dutch_`, `_english_`, `_estonian_`, `_finnish_`, `_french_`, `_galician_`, `_german_`, `_greek_`, `_hindi_`, `_hungarian_`, `_indonesian_`, `_irish_`, `_italian_`, `_latvian_`, `_lithuanian_`, `_norwegian_`, `_persian_`, `_portuguese_`, `_romanian_`, `_russian_`, `_serbian_`, `_sorani_`, `_spanish_`, `_swedish_`, `_thai_`, `_turkish_`, `_none_`
          - `stopwords_path` (string)
          - `stem_exclusion` (string[])
        - **type: hungarian** (`type: hungarian`)
          - `type` (enum)
            Values: `hungarian`
          - `stopwords` (union oneOf)
            Values: `_arabic_`, `_armenian_`, `_basque_`, `_bengali_`, `_brazilian_`, `_bulgarian_`, `_catalan_`, `_cjk_`, `_czech_`, `_danish_`, `_dutch_`, `_english_`, `_estonian_`, `_finnish_`, `_french_`, `_galician_`, `_german_`, `_greek_`, `_hindi_`, `_hungarian_`, `_indonesian_`, `_irish_`, `_italian_`, `_latvian_`, `_lithuanian_`, `_norwegian_`, `_persian_`, `_portuguese_`, `_romanian_`, `_russian_`, `_serbian_`, `_sorani_`, `_spanish_`, `_swedish_`, `_thai_`, `_turkish_`, `_none_`
          - `stopwords_path` (string)
          - `stem_exclusion` (string[])
        - **type: indonesian** (`type: indonesian`)
          - `type` (enum)
            Values: `indonesian`
          - `stopwords` (union oneOf)
            Values: `_arabic_`, `_armenian_`, `_basque_`, `_bengali_`, `_brazilian_`, `_bulgarian_`, `_catalan_`, `_cjk_`, `_czech_`, `_danish_`, `_dutch_`, `_english_`, `_estonian_`, `_finnish_`, `_french_`, `_galician_`, `_german_`, `_greek_`, `_hindi_`, `_hungarian_`, `_indonesian_`, `_irish_`, `_italian_`, `_latvian_`, `_lithuanian_`, `_norwegian_`, `_persian_`, `_portuguese_`, `_romanian_`, `_russian_`, `_serbian_`, `_sorani_`, `_spanish_`, `_swedish_`, `_thai_`, `_turkish_`, `_none_`
          - `stopwords_path` (string)
          - `stem_exclusion` (string[])
        - **type: irish** (`type: irish`)
          - `type` (enum)
            Values: `irish`
          - `stopwords` (union oneOf)
            Values: `_arabic_`, `_armenian_`, `_basque_`, `_bengali_`, `_brazilian_`, `_bulgarian_`, `_catalan_`, `_cjk_`, `_czech_`, `_danish_`, `_dutch_`, `_english_`, `_estonian_`, `_finnish_`, `_french_`, `_galician_`, `_german_`, `_greek_`, `_hindi_`, `_hungarian_`, `_indonesian_`, `_irish_`, `_italian_`, `_latvian_`, `_lithuanian_`, `_norwegian_`, `_persian_`, `_portuguese_`, `_romanian_`, `_russian_`, `_serbian_`, `_sorani_`, `_spanish_`, `_swedish_`, `_thai_`, `_turkish_`, `_none_`
          - `stopwords_path` (string)
          - `stem_exclusion` (string[])
        - **type: italian** (`type: italian`)
          - `type` (enum)
            Values: `italian`
          - `stopwords` (union oneOf)
            Values: `_arabic_`, `_armenian_`, `_basque_`, `_bengali_`, `_brazilian_`, `_bulgarian_`, `_catalan_`, `_cjk_`, `_czech_`, `_danish_`, `_dutch_`, `_english_`, `_estonian_`, `_finnish_`, `_french_`, `_galician_`, `_german_`, `_greek_`, `_hindi_`, `_hungarian_`, `_indonesian_`, `_irish_`, `_italian_`, `_latvian_`, `_lithuanian_`, `_norwegian_`, `_persian_`, `_portuguese_`, `_romanian_`, `_russian_`, `_serbian_`, `_sorani_`, `_spanish_`, `_swedish_`, `_thai_`, `_turkish_`, `_none_`
          - `stopwords_path` (string)
          - `stem_exclusion` (string[])
        - **type: latvian** (`type: latvian`)
          - `type` (enum)
            Values: `latvian`
          - `stopwords` (union oneOf)
            Values: `_arabic_`, `_armenian_`, `_basque_`, `_bengali_`, `_brazilian_`, `_bulgarian_`, `_catalan_`, `_cjk_`, `_czech_`, `_danish_`, `_dutch_`, `_english_`, `_estonian_`, `_finnish_`, `_french_`, `_galician_`, `_german_`, `_greek_`, `_hindi_`, `_hungarian_`, `_indonesian_`, `_irish_`, `_italian_`, `_latvian_`, `_lithuanian_`, `_norwegian_`, `_persian_`, `_portuguese_`, `_romanian_`, `_russian_`, `_serbian_`, `_sorani_`, `_spanish_`, `_swedish_`, `_thai_`, `_turkish_`, `_none_`
          - `stopwords_path` (string)
          - `stem_exclusion` (string[])
        - **type: lithuanian** (`type: lithuanian`)
          - `type` (enum)
            Values: `lithuanian`
          - `stopwords` (union oneOf)
            Values: `_arabic_`, `_armenian_`, `_basque_`, `_bengali_`, `_brazilian_`, `_bulgarian_`, `_catalan_`, `_cjk_`, `_czech_`, `_danish_`, `_dutch_`, `_english_`, `_estonian_`, `_finnish_`, `_french_`, `_galician_`, `_german_`, `_greek_`, `_hindi_`, `_hungarian_`, `_indonesian_`, `_irish_`, `_italian_`, `_latvian_`, `_lithuanian_`, `_norwegian_`, `_persian_`, `_portuguese_`, `_romanian_`, `_russian_`, `_serbian_`, `_sorani_`, `_spanish_`, `_swedish_`, `_thai_`, `_turkish_`, `_none_`
          - `stopwords_path` (string)
          - `stem_exclusion` (string[])
        - **type: norwegian** (`type: norwegian`)
          - `type` (enum)
            Values: `norwegian`
          - `stopwords` (union oneOf)
            Values: `_arabic_`, `_armenian_`, `_basque_`, `_bengali_`, `_brazilian_`, `_bulgarian_`, `_catalan_`, `_cjk_`, `_czech_`, `_danish_`, `_dutch_`, `_english_`, `_estonian_`, `_finnish_`, `_french_`, `_galician_`, `_german_`, `_greek_`, `_hindi_`, `_hungarian_`, `_indonesian_`, `_irish_`, `_italian_`, `_latvian_`, `_lithuanian_`, `_norwegian_`, `_persian_`, `_portuguese_`, `_romanian_`, `_russian_`, `_serbian_`, `_sorani_`, `_spanish_`, `_swedish_`, `_thai_`, `_turkish_`, `_none_`
          - `stopwords_path` (string)
          - `stem_exclusion` (string[])
        - **type: persian** (`type: persian`)
          - `type` (enum)
            Values: `persian`
          - `stopwords` (union oneOf)
            Values: `_arabic_`, `_armenian_`, `_basque_`, `_bengali_`, `_brazilian_`, `_bulgarian_`, `_catalan_`, `_cjk_`, `_czech_`, `_danish_`, `_dutch_`, `_english_`, `_estonian_`, `_finnish_`, `_french_`, `_galician_`, `_german_`, `_greek_`, `_hindi_`, `_hungarian_`, `_indonesian_`, `_irish_`, `_italian_`, `_latvian_`, `_lithuanian_`, `_norwegian_`, `_persian_`, `_portuguese_`, `_romanian_`, `_russian_`, `_serbian_`, `_sorani_`, `_spanish_`, `_swedish_`, `_thai_`, `_turkish_`, `_none_`
          - `stopwords_path` (string)
        - **type: portuguese** (`type: portuguese`)
          - `type` (enum)
            Values: `portuguese`
          - `stopwords` (union oneOf)
            Values: `_arabic_`, `_armenian_`, `_basque_`, `_bengali_`, `_brazilian_`, `_bulgarian_`, `_catalan_`, `_cjk_`, `_czech_`, `_danish_`, `_dutch_`, `_english_`, `_estonian_`, `_finnish_`, `_french_`, `_galician_`, `_german_`, `_greek_`, `_hindi_`, `_hungarian_`, `_indonesian_`, `_irish_`, `_italian_`, `_latvian_`, `_lithuanian_`, `_norwegian_`, `_persian_`, `_portuguese_`, `_romanian_`, `_russian_`, `_serbian_`, `_sorani_`, `_spanish_`, `_swedish_`, `_thai_`, `_turkish_`, `_none_`
          - `stopwords_path` (string)
          - `stem_exclusion` (string[])
        - **type: romanian** (`type: romanian`)
          - `type` (enum)
            Values: `romanian`
          - `stopwords` (union oneOf)
            Values: `_arabic_`, `_armenian_`, `_basque_`, `_bengali_`, `_brazilian_`, `_bulgarian_`, `_catalan_`, `_cjk_`, `_czech_`, `_danish_`, `_dutch_`, `_english_`, `_estonian_`, `_finnish_`, `_french_`, `_galician_`, `_german_`, `_greek_`, `_hindi_`, `_hungarian_`, `_indonesian_`, `_irish_`, `_italian_`, `_latvian_`, `_lithuanian_`, `_norwegian_`, `_persian_`, `_portuguese_`, `_romanian_`, `_russian_`, `_serbian_`, `_sorani_`, `_spanish_`, `_swedish_`, `_thai_`, `_turkish_`, `_none_`
          - `stopwords_path` (string)
          - `stem_exclusion` (string[])
        - **type: russian** (`type: russian`)
          - `type` (enum)
            Values: `russian`
          - `stopwords` (union oneOf)
            Values: `_arabic_`, `_armenian_`, `_basque_`, `_bengali_`, `_brazilian_`, `_bulgarian_`, `_catalan_`, `_cjk_`, `_czech_`, `_danish_`, `_dutch_`, `_english_`, `_estonian_`, `_finnish_`, `_french_`, `_galician_`, `_german_`, `_greek_`, `_hindi_`, `_hungarian_`, `_indonesian_`, `_irish_`, `_italian_`, `_latvian_`, `_lithuanian_`, `_norwegian_`, `_persian_`, `_portuguese_`, `_romanian_`, `_russian_`, `_serbian_`, `_sorani_`, `_spanish_`, `_swedish_`, `_thai_`, `_turkish_`, `_none_`
          - `stopwords_path` (string)
          - `stem_exclusion` (string[])
        - **type: serbian** (`type: serbian`)
          - `type` (enum)
            Values: `serbian`
          - `stopwords` (union oneOf)
            Values: `_arabic_`, `_armenian_`, `_basque_`, `_bengali_`, `_brazilian_`, `_bulgarian_`, `_catalan_`, `_cjk_`, `_czech_`, `_danish_`, `_dutch_`, `_english_`, `_estonian_`, `_finnish_`, `_french_`, `_galician_`, `_german_`, `_greek_`, `_hindi_`, `_hungarian_`, `_indonesian_`, `_irish_`, `_italian_`, `_latvian_`, `_lithuanian_`, `_norwegian_`, `_persian_`, `_portuguese_`, `_romanian_`, `_russian_`, `_serbian_`, `_sorani_`, `_spanish_`, `_swedish_`, `_thai_`, `_turkish_`, `_none_`
          - `stopwords_path` (string)
          - `stem_exclusion` (string[])
        - **type: sorani** (`type: sorani`)
          - `type` (enum)
            Values: `sorani`
          - `stopwords` (union oneOf)
            Values: `_arabic_`, `_armenian_`, `_basque_`, `_bengali_`, `_brazilian_`, `_bulgarian_`, `_catalan_`, `_cjk_`, `_czech_`, `_danish_`, `_dutch_`, `_english_`, `_estonian_`, `_finnish_`, `_french_`, `_galician_`, `_german_`, `_greek_`, `_hindi_`, `_hungarian_`, `_indonesian_`, `_irish_`, `_italian_`, `_latvian_`, `_lithuanian_`, `_norwegian_`, `_persian_`, `_portuguese_`, `_romanian_`, `_russian_`, `_serbian_`, `_sorani_`, `_spanish_`, `_swedish_`, `_thai_`, `_turkish_`, `_none_`
          - `stopwords_path` (string)
          - `stem_exclusion` (string[])
        - **type: spanish** (`type: spanish`)
          - `type` (enum)
            Values: `spanish`
          - `stopwords` (union oneOf)
            Values: `_arabic_`, `_armenian_`, `_basque_`, `_bengali_`, `_brazilian_`, `_bulgarian_`, `_catalan_`, `_cjk_`, `_czech_`, `_danish_`, `_dutch_`, `_english_`, `_estonian_`, `_finnish_`, `_french_`, `_galician_`, `_german_`, `_greek_`, `_hindi_`, `_hungarian_`, `_indonesian_`, `_irish_`, `_italian_`, `_latvian_`, `_lithuanian_`, `_norwegian_`, `_persian_`, `_portuguese_`, `_romanian_`, `_russian_`, `_serbian_`, `_sorani_`, `_spanish_`, `_swedish_`, `_thai_`, `_turkish_`, `_none_`
          - `stopwords_path` (string)
          - `stem_exclusion` (string[])
        - **type: swedish** (`type: swedish`)
          - `type` (enum)
            Values: `swedish`
          - `stopwords` (union oneOf)
            Values: `_arabic_`, `_armenian_`, `_basque_`, `_bengali_`, `_brazilian_`, `_bulgarian_`, `_catalan_`, `_cjk_`, `_czech_`, `_danish_`, `_dutch_`, `_english_`, `_estonian_`, `_finnish_`, `_french_`, `_galician_`, `_german_`, `_greek_`, `_hindi_`, `_hungarian_`, `_indonesian_`, `_irish_`, `_italian_`, `_latvian_`, `_lithuanian_`, `_norwegian_`, `_persian_`, `_portuguese_`, `_romanian_`, `_russian_`, `_serbian_`, `_sorani_`, `_spanish_`, `_swedish_`, `_thai_`, `_turkish_`, `_none_`
          - `stopwords_path` (string)
          - `stem_exclusion` (string[])
        - **type: turkish** (`type: turkish`)
          - `type` (enum)
            Values: `turkish`
          - `stopwords` (union oneOf)
            Values: `_arabic_`, `_armenian_`, `_basque_`, `_bengali_`, `_brazilian_`, `_bulgarian_`, `_catalan_`, `_cjk_`, `_czech_`, `_danish_`, `_dutch_`, `_english_`, `_estonian_`, `_finnish_`, `_french_`, `_galician_`, `_german_`, `_greek_`, `_hindi_`, `_hungarian_`, `_indonesian_`, `_irish_`, `_italian_`, `_latvian_`, `_lithuanian_`, `_norwegian_`, `_persian_`, `_portuguese_`, `_romanian_`, `_russian_`, `_serbian_`, `_sorani_`, `_spanish_`, `_swedish_`, `_thai_`, `_turkish_`, `_none_`
          - `stopwords_path` (string)
          - `stem_exclusion` (string[])
        - **type: thai** (`type: thai`)
          - `type` (enum)
            Values: `thai`
          - `stopwords` (union oneOf)
            Values: `_arabic_`, `_armenian_`, `_basque_`, `_bengali_`, `_brazilian_`, `_bulgarian_`, `_catalan_`, `_cjk_`, `_czech_`, `_danish_`, `_dutch_`, `_english_`, `_estonian_`, `_finnish_`, `_french_`, `_galician_`, `_german_`, `_greek_`, `_hindi_`, `_hungarian_`, `_indonesian_`, `_irish_`, `_italian_`, `_latvian_`, `_lithuanian_`, `_norwegian_`, `_persian_`, `_portuguese_`, `_romanian_`, `_russian_`, `_serbian_`, `_sorani_`, `_spanish_`, `_swedish_`, `_thai_`, `_turkish_`, `_none_`
          - `stopwords_path` (string)
      - `char_filter` (map string to oneOf)
        Map values (union oneOf)
        One of:
        - **string**
        - **CharFilterDefinition**
          One of:
          - **type: html_strip** (`type: html_strip`)
            - `type` (enum)
              Values: `html_strip`
            - `version` (string)
            - `escaped_tags` (string[])
          - **type: mapping** (`type: mapping`)
            - `type` (enum)
              Values: `mapping`
            - `version` (string)
            - `mappings` (string[])
            - `mappings_path` (string)
          - **type: pattern_replace** (`type: pattern_replace`)
            - `type` (enum)
              Values: `pattern_replace`
            - `version` (string)
            - `flags` (string)
            - `pattern` (string)
            - `replacement` (string)
          - **type: icu_normalizer** (`type: icu_normalizer`)
            - `type` (enum)
              Values: `icu_normalizer`
            - `version` (string)
            - `mode` (enum)
              Values: `decompose`, `compose`
            - `name` (enum)
              Values: `nfc`, `nfkc`, `nfkc_cf`
            - `unicode_set_filter` (string)
          - **type: kuromoji_iteration_mark** (`type: kuromoji_iteration_mark`)
            - `type` (enum)
              Values: `kuromoji_iteration_mark`
            - `version` (string)
            - `normalize_kana` (boolean)
            - `normalize_kanji` (boolean)
      - `filter` (map string to oneOf)
        Map values (union oneOf)
        One of:
        - **string**
        - **TokenFilterDefinition**
          One of:
          - **type: apostrophe** (`type: apostrophe`)
            - `type` (enum)
              Values: `apostrophe`
            - `version` (string)
          - **type: arabic_stem** (`type: arabic_stem`)
            - `type` (enum)
              Values: `arabic_stem`
            - `version` (string)
          - **type: arabic_normalization** (`type: arabic_normalization`)
            - `type` (enum)
              Values: `arabic_normalization`
            - `version` (string)
          - **type: asciifolding** (`type: asciifolding`)
            - `type` (enum)
              Values: `asciifolding`
            - `version` (string)
            - `preserve_original` (boolean | string)
              If `true`, emit both original tokens and folded tokens. Defaults to `false`.
          - **type: bengali_normalization** (`type: bengali_normalization`)
            - `type` (enum)
              Values: `bengali_normalization`
            - `version` (string)
          - **type: brazilian_stem** (`type: brazilian_stem`)
            - `type` (enum)
              Values: `brazilian_stem`
            - `version` (string)
          - **type: cjk_bigram** (`type: cjk_bigram`)
            - `type` (enum)
              Values: `cjk_bigram`
            - `version` (string)
            - `ignored_scripts` (enum[])
              Array of character scripts for which to disable bigrams.
              Values: `han`, `hangul`, `hiragana`, `katakana`
            - `output_unigrams` (boolean)
              If `true`, emit tokens in both bigram and unigram form. If `false`, a CJK character is output in unigram form when it has no adjacent characters. Defaults to `false`.
          - **type: cjk_width** (`type: cjk_width`)
            - `type` (enum)
              Values: `cjk_width`
            - `version` (string)
          - **type: classic** (`type: classic`)
            - `type` (enum)
              Values: `classic`
            - `version` (string)
          - **type: common_grams** (`type: common_grams`)
            - `type` (enum)
              Values: `common_grams`
            - `version` (string)
            - `common_words` (string[])
              A list of tokens. The filter generates bigrams for these tokens.
Either this or the `common_words_path` parameter is required.
            - `common_words_path` (string)
              Path to a file containing a list of tokens. The filter generates bigrams for these tokens.
This path must be absolute or relative to the `config` location. The file must be UTF-8 encoded. Each token in the file must be separated by a line break.
Either this or the `common_words` parameter is required.
            - `ignore_case` (boolean)
              If `true`, matches for common words matching are case-insensitive. Defaults to `false`.
            - `query_mode` (boolean)
              If `true`, the filter excludes the following tokens from the output:
- Unigrams for common words
- Unigrams for terms followed by common words
Defaults to `false`. We recommend enabling this parameter for search analyzers.
          - **type: condition** (`type: condition`)
            - `type` (enum)
              Values: `condition`
            - `version` (string)
            - `filter` (string[])
              Array of token filters. If a token matches the predicate script in the `script` parameter, these filters are applied to the token in the order provided.
            - `script` (string)
              Predicate script used to apply token filters. If a token matches this script, the filters in the `filter` parameter are applied to the token.
          - **type: czech_stem** (`type: czech_stem`)
            - `type` (enum)
              Values: `czech_stem`
            - `version` (string)
          - **type: decimal_digit** (`type: decimal_digit`)
            - `type` (enum)
              Values: `decimal_digit`
            - `version` (string)
          - **type: delimited_payload** (`type: delimited_payload`)
            - `type` (enum)
              Values: `delimited_payload`
            - `version` (string)
            - `delimiter` (string)
              Character used to separate tokens from payloads. Defaults to `|`.
            - `encoding` (enum)
              Data type for the stored payload.
              Values: `int`, `float`, `identity`
          - **type: dutch_stem** (`type: dutch_stem`)
            - `type` (enum)
              Values: `dutch_stem`
            - `version` (string)
          - **type: edge_ngram** (`type: edge_ngram`)
            - `type` (enum)
              Values: `edge_ngram`
            - `version` (string)
            - `max_gram` (number)
              Maximum character length of a gram. For custom token filters, defaults to `2`. For the built-in edge_ngram filter, defaults to `1`.
            - `min_gram` (number)
              Minimum character length of a gram. Defaults to `1`.
            - `side` (enum)
              Indicates whether to truncate tokens from the `front` or `back`. Defaults to `front`.
              Values: `front`, `back`
            - `preserve_original` (boolean | string)
              Emits original token when set to `true`. Defaults to `false`.
          - **type: elision** (`type: elision`)
            - `type` (enum)
              Values: `elision`
            - `version` (string)
            - `articles` (string[])
              List of elisions to remove.
To be removed, the elision must be at the beginning of a token and be immediately followed by an apostrophe. Both the elision and apostrophe are removed.
For custom `elision` filters, either this parameter or `articles_path` must be specified.
            - `articles_path` (string)
              Path to a file that contains a list of elisions to remove.
This path must be absolute or relative to the `config` location, and the file must be UTF-8 encoded. Each elision in the file must be separated by a line break.
To be removed, the elision must be at the beginning of a token and be immediately followed by an apostrophe. Both the elision and apostrophe are removed.
For custom `elision` filters, either this parameter or `articles` must be specified.
            - `articles_case` (boolean | string)
              If `true`, elision matching is case insensitive. If `false`, elision matching is case sensitive. Defaults to `false`.
          - **type: fingerprint** (`type: fingerprint`)
            - `type` (enum)
              Values: `fingerprint`
            - `version` (string)
            - `max_output_size` (number)
              Maximum character length, including whitespace, of the output token. Defaults to `255`. Concatenated tokens longer than this will result in no token output.
            - `separator` (string)
              Character to use to concatenate the token stream input. Defaults to a space.
          - **type: flatten_graph** (`type: flatten_graph`)
            - `type` (enum)
              Values: `flatten_graph`
            - `version` (string)
          - **type: french_stem** (`type: french_stem`)
            - `type` (enum)
              Values: `french_stem`
            - `version` (string)
          - **type: german_normalization** (`type: german_normalization`)
            - `type` (enum)
              Values: `german_normalization`
            - `version` (string)
          - **type: german_stem** (`type: german_stem`)
            - `type` (enum)
              Values: `german_stem`
            - `version` (string)
          - **type: hindi_normalization** (`type: hindi_normalization`)
            - `type` (enum)
              Values: `hindi_normalization`
            - `version` (string)
          - **type: hunspell** (`type: hunspell`)
            - `type` (enum)
              Values: `hunspell`
            - `version` (string)
            - `dedup` (boolean)
              If `true`, duplicate tokens are removed from the filter’s output. Defaults to `true`.
            - `dictionary` (string)
              One or more `.dic` files (e.g, `en_US.dic`, my_custom.dic) to use for the Hunspell dictionary.
By default, the `hunspell` filter uses all `.dic` files in the `<$ES_PATH_CONF>/hunspell/<locale>` directory specified using the `lang`, `language`, or `locale` parameter.
            - `locale` (string)
              Locale directory used to specify the `.aff` and `.dic` files for a Hunspell dictionary.
            - `longest_only` (boolean)
              If `true`, only the longest stemmed version of each token is included in the output. If `false`, all stemmed versions of the token are included. Defaults to `false`.
          - **type: hyphenation_decompounder** (`type: hyphenation_decompounder`)
            - `type` (enum)
              Values: `hyphenation_decompounder`
            - `version` (string)
            - `max_subword_size` (number)
              Maximum subword character length. Longer subword tokens are excluded from the output. Defaults to `15`.
            - `min_subword_size` (number)
              Minimum subword character length. Shorter subword tokens are excluded from the output. Defaults to `2`.
            - `min_word_size` (number)
              Minimum word character length. Shorter word tokens are excluded from the output. Defaults to `5`.
            - `only_longest_match` (boolean)
              If `true`, only include the longest matching subword. Defaults to `false`.
            - `word_list` (string[])
              A list of subwords to look for in the token stream. If found, the subword is included in the token output.
Either this parameter or `word_list_path` must be specified.
            - `word_list_path` (string)
              Path to a file that contains a list of subwords to find in the token stream. If found, the subword is included in the token output.
This path must be absolute or relative to the config location, and the file must be UTF-8 encoded. Each token in the file must be separated by a line break.
Either this parameter or `word_list` must be specified.
            - `hyphenation_patterns_path` (string)
              Path to an Apache FOP (Formatting Objects Processor) XML hyphenation pattern file.
This path must be absolute or relative to the `config` location. Only FOP v1.2 compatible files are supported.
            - `no_sub_matches` (boolean)
              If `true`, do not match sub tokens in tokens that are in the word list. Defaults to `false`.
            - `no_overlapping_matches` (boolean)
              If `true`, do not allow overlapping tokens. Defaults to `false`.
          - **type: indic_normalization** (`type: indic_normalization`)
            - `type` (enum)
              Values: `indic_normalization`
            - `version` (string)
          - **type: keep_types** (`type: keep_types`)
            - `type` (enum)
              Values: `keep_types`
            - `version` (string)
            - `mode` (enum)
              Indicates whether to keep or remove the specified token types.
              Values: `include`, `exclude`
            - `types` (string[])
              List of token types to keep or remove.
          - **type: keep** (`type: keep`)
            - `type` (enum)
              Values: `keep`
            - `version` (string)
            - `keep_words` (string[])
              List of words to keep. Only tokens that match words in this list are included in the output.
Either this parameter or `keep_words_path` must be specified.
            - `keep_words_case` (boolean)
              If `true`, lowercase all keep words. Defaults to `false`.
            - `keep_words_path` (string)
              Path to a file that contains a list of words to keep. Only tokens that match words in this list are included in the output.
This path must be absolute or relative to the `config` location, and the file must be UTF-8 encoded. Each word in the file must be separated by a line break.
Either this parameter or `keep_words` must be specified.
          - **type: keyword_marker** (`type: keyword_marker`)
            - `type` (enum)
              Values: `keyword_marker`
            - `version` (string)
            - `ignore_case` (boolean)
              If `true`, matching for the `keywords` and `keywords_path` parameters ignores letter case. Defaults to `false`.
            - `keywords` (union string | string[])
              Array of keywords. Tokens that match these keywords are not stemmed.
This parameter, `keywords_path`, or `keywords_pattern` must be specified. You cannot specify this parameter and `keywords_pattern`.
            - `keywords_path` (string)
              Path to a file that contains a list of keywords. Tokens that match these keywords are not stemmed.
This path must be absolute or relative to the `config` location, and the file must be UTF-8 encoded. Each word in the file must be separated by a line break.
This parameter, `keywords`, or `keywords_pattern` must be specified. You cannot specify this parameter and `keywords_pattern`.
            - `keywords_pattern` (string)
              Java regular expression used to match tokens. Tokens that match this expression are marked as keywords and not stemmed.
This parameter, `keywords`, or `keywords_path` must be specified. You cannot specify this parameter and `keywords` or `keywords_pattern`.
          - **type: keyword_repeat** (`type: keyword_repeat`)
            - `type` (enum)
              Values: `keyword_repeat`
            - `version` (string)
          - **type: kstem** (`type: kstem`)
            - `type` (enum)
              Values: `kstem`
            - `version` (string)
          - **type: length** (`type: length`)
            - `type` (enum)
              Values: `length`
            - `version` (string)
            - `max` (number)
              Maximum character length of a token. Longer tokens are excluded from the output. Defaults to `Integer.MAX_VALUE`, which is `2^31-1` or `2147483647`.
            - `min` (number)
              Minimum character length of a token. Shorter tokens are excluded from the output. Defaults to `0`.
          - **type: limit** (`type: limit`)
            - `type` (enum)
              Values: `limit`
            - `version` (string)
            - `consume_all_tokens` (boolean)
              If `true`, the limit filter exhausts the token stream, even if the `max_token_count` has already been reached. Defaults to `false`.
            - `max_token_count` (number | string)
              Maximum number of tokens to keep. Once this limit is reached, any remaining tokens are excluded from the output. Defaults to `1`.
          - **type: lowercase** (`type: lowercase`)
            - `type` (enum)
              Values: `lowercase`
            - `version` (string)
            - `language` (enum)
              Language-specific lowercase token filter to use.
              Values: `greek`, `irish`, `turkish`
          - **type: min_hash** (`type: min_hash`)
            - `type` (enum)
              Values: `min_hash`
            - `version` (string)
            - `bucket_count` (number)
              Number of buckets to which hashes are assigned. Defaults to `512`.
            - `hash_count` (number)
              Number of ways to hash each token in the stream. Defaults to `1`.
            - `hash_set_size` (number)
              Number of hashes to keep from each bucket. Defaults to `1`.
Hashes are retained by ascending size, starting with the bucket’s smallest hash first.
            - `with_rotation` (boolean)
              If `true`, the filter fills empty buckets with the value of the first non-empty bucket to its circular right if the `hash_set_size` is `1`. If the `bucket_count` argument is greater than 1, this parameter defaults to `true`. Otherwise, this parameter defaults to `false`.
          - **type: multiplexer** (`type: multiplexer`)
            - `type` (enum)
              Values: `multiplexer`
            - `version` (string)
            - `filters` (string[])
              A list of token filters to apply to incoming tokens.
            - `preserve_original` (boolean | string)
              If `true` (the default) then emit the original token in addition to the filtered tokens.
          - **type: ngram** (`type: ngram`)
            - `type` (enum)
              Values: `ngram`
            - `version` (string)
            - `max_gram` (number)
              Maximum length of characters in a gram. Defaults to `2`.
            - `min_gram` (number)
              Minimum length of characters in a gram. Defaults to `1`.
            - `preserve_original` (boolean | string)
              Emits original token when set to `true`. Defaults to `false`.
          - **type: nori_part_of_speech** (`type: nori_part_of_speech`)
            - `type` (enum)
              Values: `nori_part_of_speech`
            - `version` (string)
            - `stoptags` (string[])
              An array of part-of-speech tags that should be removed.
          - **type: pattern_capture** (`type: pattern_capture`)
            - `type` (enum)
              Values: `pattern_capture`
            - `version` (string)
            - `patterns` (string[])
              A list of regular expressions to match.
            - `preserve_original` (boolean | string)
              If set to `true` (the default) it will emit the original token.
          - **type: pattern_replace** (`type: pattern_replace`)
            - `type` (enum)
              Values: `pattern_replace`
            - `version` (string)
            - `all` (boolean)
              If `true`, all substrings matching the pattern parameter’s regular expression are replaced. If `false`, the filter replaces only the first matching substring in each token. Defaults to `true`.
            - `flags` (string)
            - `pattern` (string)
              Regular expression, written in Java’s regular expression syntax. The filter replaces token substrings matching this pattern with the substring in the `replacement` parameter.
            - `replacement` (string)
              Replacement substring. Defaults to an empty substring (`""`).
          - **type: persian_normalization** (`type: persian_normalization`)
            - `type` (enum)
              Values: `persian_normalization`
            - `version` (string)
          - **type: persian_stem** (`type: persian_stem`)
            - `type` (enum)
              Values: `persian_stem`
            - `version` (string)
          - **type: porter_stem** (`type: porter_stem`)
            - `type` (enum)
              Values: `porter_stem`
            - `version` (string)
          - **type: predicate_token_filter** (`type: predicate_token_filter`)
            - `type` (enum)
              Values: `predicate_token_filter`
            - `version` (string)
            - `script` (string)
              Script containing a condition used to filter incoming tokens. Only tokens that match this script are included in the output.
          - **type: remove_duplicates** (`type: remove_duplicates`)
            - `type` (enum)
              Values: `remove_duplicates`
            - `version` (string)
          - **type: reverse** (`type: reverse`)
            - `type` (enum)
              Values: `reverse`
            - `version` (string)
          - **type: russian_stem** (`type: russian_stem`)
            - `type` (enum)
              Values: `russian_stem`
            - `version` (string)
          - **type: scandinavian_folding** (`type: scandinavian_folding`)
            - `type` (enum)
              Values: `scandinavian_folding`
            - `version` (string)
          - **type: scandinavian_normalization** (`type: scandinavian_normalization`)
            - `type` (enum)
              Values: `scandinavian_normalization`
            - `version` (string)
          - **type: serbian_normalization** (`type: serbian_normalization`)
            - `type` (enum)
              Values: `serbian_normalization`
            - `version` (string)
          - **type: shingle** (`type: shingle`)
            - `type` (enum)
              Values: `shingle`
            - `version` (string)
            - `filler_token` (string)
              String used in shingles as a replacement for empty positions that do not contain a token. This filler token is only used in shingles, not original unigrams. Defaults to an underscore (`_`).
            - `max_shingle_size` (number | string)
              Maximum number of tokens to concatenate when creating shingles. Defaults to `2`.
            - `min_shingle_size` (number | string)
              Minimum number of tokens to concatenate when creating shingles. Defaults to `2`.
            - `output_unigrams` (boolean)
              If `true`, the output includes the original input tokens. If `false`, the output only includes shingles; the original input tokens are removed. Defaults to `true`.
            - `output_unigrams_if_no_shingles` (boolean)
              If `true`, the output includes the original input tokens only if no shingles are produced; if shingles are produced, the output only includes shingles. Defaults to `false`.
            - `token_separator` (string)
              Separator used to concatenate adjacent tokens to form a shingle. Defaults to a space (`" "`).
          - **type: snowball** (`type: snowball`)
            - `type` (enum)
              Values: `snowball`
            - `version` (string)
            - `language` (enum)
              Controls the language used by the stemmer.
              Values: `Arabic`, `Armenian`, `Basque`, `Catalan`, `Danish`, `Dutch`, `English`, `Estonian`, `Finnish`, `French`, `German`, `German2`, `Hungarian`, `Italian`, `Irish`, `Kp`, `Lithuanian`, `Lovins`, `Norwegian`, `Porter`, `Portuguese`, `Romanian`, `Russian`, `Serbian`, `Spanish`, `Swedish`, `Turkish`
          - **type: sorani_normalization** (`type: sorani_normalization`)
            - `type` (enum)
              Values: `sorani_normalization`
            - `version` (string)
          - **type: stemmer_override** (`type: stemmer_override`)
            - `type` (enum)
              Values: `stemmer_override`
            - `version` (string)
            - `rules` (string[])
              A list of mapping rules to use.
            - `rules_path` (string)
              A path (either relative to `config` location, or absolute) to a list of mappings.
          - **type: stemmer** (`type: stemmer`)
            - `type` (enum)
              Values: `stemmer`
            - `version` (string)
            - `language` (string)
          - **type: stop** (`type: stop`)
            - `type` (enum)
              Values: `stop`
            - `version` (string)
            - `ignore_case` (boolean)
              If `true`, stop word matching is case insensitive. For example, if `true`, a stop word of the matches and removes `The`, `THE`, or `the`. Defaults to `false`.
            - `remove_trailing` (boolean)
              If `true`, the last token of a stream is removed if it’s a stop word. Defaults to `true`.
            - `stopwords` (union oneOf)
              Language value, such as `_arabic_` or `_thai_`. Defaults to `_english_`.
              Values: `_arabic_`, `_armenian_`, `_basque_`, `_bengali_`, `_brazilian_`, `_bulgarian_`, `_catalan_`, `_cjk_`, `_czech_`, `_danish_`, `_dutch_`, `_english_`, `_estonian_`, `_finnish_`, `_french_`, `_galician_`, `_german_`, `_greek_`, `_hindi_`, `_hungarian_`, `_indonesian_`, `_irish_`, `_italian_`, `_latvian_`, `_lithuanian_`, `_norwegian_`, `_persian_`, `_portuguese_`, `_romanian_`, `_russian_`, `_serbian_`, `_sorani_`, `_spanish_`, `_swedish_`, `_thai_`, `_turkish_`, `_none_`
            - `stopwords_path` (string)
              Path to a file that contains a list of stop words to remove.
This path must be absolute or relative to the `config` location, and the file must be UTF-8 encoded. Each stop word in the file must be separated by a line break.
          - **type: synonym_graph** (`type: synonym_graph`)
            - `type` (enum)
              Values: `synonym_graph`
            - `version` (string)
            - `expand` (boolean)
              Expands definitions for equivalent synonym rules. Defaults to `true`.
            - `format` (enum)
              Sets the synonym rules format.
              Values: `solr`, `wordnet`
            - `lenient` (boolean)
              If `true` ignores errors while parsing the synonym rules. It is important to note that only those synonym rules which cannot get parsed are ignored. Defaults to the value of the `updateable` setting.
            - `synonyms` (string[])
              Used to define inline synonyms.
            - `synonyms_path` (string)
              Used to provide a synonym file. This path must be absolute or relative to the `config` location.
            - `synonyms_set` (union string | string[])
              Provide one or more synonym sets created through the Synonyms Management APIs. Maximum 100 sets per filter.
            - `tokenizer` (string) — deprecated
              Controls the tokenizers that will be used to tokenize the synonym, this parameter is for backwards compatibility for indices that created before 6.0.
            - `updateable` (boolean)
              If `true` allows reloading search analyzers to pick up changes to synonym files. Only to be used for search analyzers. Defaults to `false`.
          - **type: synonym** (`type: synonym`)
            - `type` (enum)
              Values: `synonym`
            - `version` (string)
            - `expand` (boolean)
              Expands definitions for equivalent synonym rules. Defaults to `true`.
            - `format` (enum)
              Sets the synonym rules format.
              Values: `solr`, `wordnet`
            - `lenient` (boolean)
              If `true` ignores errors while parsing the synonym rules. It is important to note that only those synonym rules which cannot get parsed are ignored. Defaults to the value of the `updateable` setting.
            - `synonyms` (string[])
              Used to define inline synonyms.
            - `synonyms_path` (string)
              Used to provide a synonym file. This path must be absolute or relative to the `config` location.
            - `synonyms_set` (union string | string[])
              Provide one or more synonym sets created through the Synonyms Management APIs. Maximum 100 sets per filter.
            - `tokenizer` (string) — deprecated
              Controls the tokenizers that will be used to tokenize the synonym, this parameter is for backwards compatibility for indices that created before 6.0.
            - `updateable` (boolean)
              If `true` allows reloading search analyzers to pick up changes to synonym files. Only to be used for search analyzers. Defaults to `false`.
          - **type: trim** (`type: trim`)
            - `type` (enum)
              Values: `trim`
            - `version` (string)
          - **type: truncate** (`type: truncate`)
            - `type` (enum)
              Values: `truncate`
            - `version` (string)
            - `length` (number)
              Character limit for each token. Tokens exceeding this limit are truncated. Defaults to `10`.
          - **type: unique** (`type: unique`)
            - `type` (enum)
              Values: `unique`
            - `version` (string)
            - `only_on_same_position` (boolean)
              If `true`, only remove duplicate tokens in the same position. Defaults to `false`.
          - **type: uppercase** (`type: uppercase`)
            - `type` (enum)
              Values: `uppercase`
            - `version` (string)
          - **type: word_delimiter_graph** (`type: word_delimiter_graph`)
            - `type` (enum)
              Values: `word_delimiter_graph`
            - `version` (string)
            - `catenate_all` (boolean)
              If `true`, the filter produces catenated tokens for chains of alphanumeric characters separated by non-alphabetic delimiters. Defaults to `false`.
            - `catenate_numbers` (boolean)
              If `true`, the filter produces catenated tokens for chains of numeric characters separated by non-alphabetic delimiters. Defaults to `false`.
            - `catenate_words` (boolean)
              If `true`, the filter produces catenated tokens for chains of alphabetical characters separated by non-alphabetic delimiters. Defaults to `false`.
            - `generate_number_parts` (boolean)
              If `true`, the filter includes tokens consisting of only numeric characters in the output. If `false`, the filter excludes these tokens from the output. Defaults to `true`.
            - `generate_word_parts` (boolean)
              If `true`, the filter includes tokens consisting of only alphabetical characters in the output. If `false`, the filter excludes these tokens from the output. Defaults to `true`.
            - `preserve_original` (boolean | string)
              If `true`, the filter includes the original version of any split tokens in the output. This original version includes non-alphanumeric delimiters. Defaults to `false`.
            - `protected_words` (string[])
              Array of tokens the filter won’t split.
            - `protected_words_path` (string)
              Path to a file that contains a list of tokens the filter won’t split.
This path must be absolute or relative to the `config` location, and the file must be UTF-8 encoded. Each token in the file must be separated by a line break.
            - `split_on_case_change` (boolean)
              If `true`, the filter splits tokens at letter case transitions. For example: camelCase -> [ camel, Case ]. Defaults to `true`.
            - `split_on_numerics` (boolean)
              If `true`, the filter splits tokens at letter-number transitions. For example: j2se -> [ j, 2, se ]. Defaults to `true`.
            - `stem_english_possessive` (boolean)
              If `true`, the filter removes the English possessive (`'s`) from the end of each token. For example: O'Neil's -> [ O, Neil ]. Defaults to `true`.
            - `type_table` (string[])
              Array of custom type mappings for characters. This allows you to map non-alphanumeric characters as numeric or alphanumeric to avoid splitting on those characters.
            - `type_table_path` (string)
              Path to a file that contains custom type mappings for characters. This allows you to map non-alphanumeric characters as numeric or alphanumeric to avoid splitting on those characters.
            - `adjust_offsets` (boolean)
              If `true`, the filter adjusts the offsets of split or catenated tokens to better reflect their actual position in the token stream. Defaults to `true`.
            - `ignore_keywords` (boolean)
              If `true`, the filter skips tokens with a keyword attribute of true. Defaults to `false`.
          - **type: word_delimiter** (`type: word_delimiter`)
            - `type` (enum)
              Values: `word_delimiter`
            - `version` (string)
            - `catenate_all` (boolean)
              If `true`, the filter produces catenated tokens for chains of alphanumeric characters separated by non-alphabetic delimiters. Defaults to `false`.
            - `catenate_numbers` (boolean)
              If `true`, the filter produces catenated tokens for chains of numeric characters separated by non-alphabetic delimiters. Defaults to `false`.
            - `catenate_words` (boolean)
              If `true`, the filter produces catenated tokens for chains of alphabetical characters separated by non-alphabetic delimiters. Defaults to `false`.
            - `generate_number_parts` (boolean)
              If `true`, the filter includes tokens consisting of only numeric characters in the output. If `false`, the filter excludes these tokens from the output. Defaults to `true`.
            - `generate_word_parts` (boolean)
              If `true`, the filter includes tokens consisting of only alphabetical characters in the output. If `false`, the filter excludes these tokens from the output. Defaults to `true`.
            - `preserve_original` (boolean | string)
              If `true`, the filter includes the original version of any split tokens in the output. This original version includes non-alphanumeric delimiters. Defaults to `false`.
            - `protected_words` (string[])
              Array of tokens the filter won’t split.
            - `protected_words_path` (string)
              Path to a file that contains a list of tokens the filter won’t split.
This path must be absolute or relative to the `config` location, and the file must be UTF-8 encoded. Each token in the file must be separated by a line break.
            - `split_on_case_change` (boolean)
              If `true`, the filter splits tokens at letter case transitions. For example: camelCase -> [ camel, Case ]. Defaults to `true`.
            - `split_on_numerics` (boolean)
              If `true`, the filter splits tokens at letter-number transitions. For example: j2se -> [ j, 2, se ]. Defaults to `true`.
            - `stem_english_possessive` (boolean)
              If `true`, the filter removes the English possessive (`'s`) from the end of each token. For example: O'Neil's -> [ O, Neil ]. Defaults to `true`.
            - `type_table` (string[])
              Array of custom type mappings for characters. This allows you to map non-alphanumeric characters as numeric or alphanumeric to avoid splitting on those characters.
            - `type_table_path` (string)
              Path to a file that contains custom type mappings for characters. This allows you to map non-alphanumeric characters as numeric or alphanumeric to avoid splitting on those characters.
          - **type: ja_stop** (`type: ja_stop`)
            - `type` (enum)
              Values: `ja_stop`
            - `version` (string)
            - `stopwords` (union oneOf)
              Values: `_arabic_`, `_armenian_`, `_basque_`, `_bengali_`, `_brazilian_`, `_bulgarian_`, `_catalan_`, `_cjk_`, `_czech_`, `_danish_`, `_dutch_`, `_english_`, `_estonian_`, `_finnish_`, `_french_`, `_galician_`, `_german_`, `_greek_`, `_hindi_`, `_hungarian_`, `_indonesian_`, `_irish_`, `_italian_`, `_latvian_`, `_lithuanian_`, `_norwegian_`, `_persian_`, `_portuguese_`, `_romanian_`, `_russian_`, `_serbian_`, `_sorani_`, `_spanish_`, `_swedish_`, `_thai_`, `_turkish_`, `_none_`
          - **type: kuromoji_stemmer** (`type: kuromoji_stemmer`)
            - `type` (enum)
              Values: `kuromoji_stemmer`
            - `version` (string)
            - `minimum_length` (number)
          - **type: kuromoji_readingform** (`type: kuromoji_readingform`)
            - `type` (enum)
              Values: `kuromoji_readingform`
            - `version` (string)
            - `use_romaji` (boolean)
          - **type: kuromoji_part_of_speech** (`type: kuromoji_part_of_speech`)
            - `type` (enum)
              Values: `kuromoji_part_of_speech`
            - `version` (string)
            - `stoptags` (string[])
          - **type: icu_collation** (`type: icu_collation`)
            - `type` (enum)
              Values: `icu_collation`
            - `version` (string)
            - `alternate` (enum)
              Values: `shifted`, `non-ignorable`
            - `caseFirst` (enum)
              Values: `lower`, `upper`
            - `caseLevel` (boolean)
            - `country` (string)
            - `decomposition` (enum)
              Values: `no`, `identical`
            - `hiraganaQuaternaryMode` (boolean)
            - `language` (string)
            - `numeric` (boolean)
            - `rules` (string)
            - `strength` (enum)
              Values: `primary`, `secondary`, `tertiary`, `quaternary`, `identical`
            - `variableTop` (string)
            - `variant` (string)
          - **type: icu_folding** (`type: icu_folding`)
            - `type` (enum)
              Values: `icu_folding`
            - `version` (string)
            - `unicode_set_filter` (string)
          - **type: icu_normalizer** (`type: icu_normalizer`)
            - `type` (enum)
              Values: `icu_normalizer`
            - `version` (string)
            - `name` (enum)
              Values: `nfc`, `nfkc`, `nfkc_cf`
          - **type: icu_transform** (`type: icu_transform`)
            - `type` (enum)
              Values: `icu_transform`
            - `version` (string)
            - `dir` (enum)
              Values: `forward`, `reverse`
            - `id` (string)
          - **type: phonetic** (`type: phonetic`)
            - `type` (enum)
              Values: `phonetic`
            - `version` (string)
            - `encoder` (enum)
              Values: `metaphone`, `double_metaphone`, `soundex`, `refined_soundex`, `caverphone1`, `caverphone2`, `cologne`, `nysiis`, `koelnerphonetik`, `haasephonetik`, `beider_morse`, `daitch_mokotoff`
            - `languageset` (union enum | enum[])
              

Supported values include: `any`, `common`, `cyrillic`, `english`, `french`, `german`, `hebrew`, `hungarian`, `polish`, `romanian`, `russian`, `spanish`
              Values: `any`, `common`, `cyrillic`, `english`, `french`, `german`, `hebrew`, `hungarian`, `polish`, `romanian`, `russian`, `spanish`
            - `max_code_len` (number)
            - `name_type` (enum)
              Values: `generic`, `ashkenazi`, `sephardic`
            - `replace` (boolean)
            - `rule_type` (enum)
              Values: `approx`, `exact`
          - **type: dictionary_decompounder** (`type: dictionary_decompounder`)
            - `type` (enum)
              Values: `dictionary_decompounder`
            - `version` (string)
            - `max_subword_size` (number)
              Maximum subword character length. Longer subword tokens are excluded from the output. Defaults to `15`.
            - `min_subword_size` (number)
              Minimum subword character length. Shorter subword tokens are excluded from the output. Defaults to `2`.
            - `min_word_size` (number)
              Minimum word character length. Shorter word tokens are excluded from the output. Defaults to `5`.
            - `only_longest_match` (boolean)
              If `true`, only include the longest matching subword. Defaults to `false`.
            - `word_list` (string[])
              A list of subwords to look for in the token stream. If found, the subword is included in the token output.
Either this parameter or `word_list_path` must be specified.
            - `word_list_path` (string)
              Path to a file that contains a list of subwords to find in the token stream. If found, the subword is included in the token output.
This path must be absolute or relative to the config location, and the file must be UTF-8 encoded. Each token in the file must be separated by a line break.
Either this parameter or `word_list` must be specified.
      - `normalizer` (map string to oneOf)
        Map values (union oneOf)
        One of:
        - **type: lowercase** (`type: lowercase`)
          - `type` (enum)
            Values: `lowercase`
        - **type: custom** (`type: custom`)
          - `type` (enum)
            Values: `custom`
          - `char_filter` (string[])
          - `filter` (string[])
      - `tokenizer` (map string to oneOf)
        Map values (union oneOf)
        One of:
        - **string**
        - **TokenizerDefinition**
          One of:
          - **type: char_group** (`type: char_group`)
            - `type` (enum)
              Values: `char_group`
            - `version` (string)
            - `tokenize_on_chars` (string[])
            - `max_token_length` (number)
          - **type: classic** (`type: classic`)
            - `type` (enum)
              Values: `classic`
            - `version` (string)
            - `max_token_length` (number)
          - **type: edge_ngram** (`type: edge_ngram`)
            - `type` (enum)
              Values: `edge_ngram`
            - `version` (string)
            - `custom_token_chars` (string)
            - `max_gram` (number)
            - `min_gram` (number)
            - `token_chars` (enum[] · default: [])
              Values: `letter`, `digit`, `whitespace`, `punctuation`, `symbol`, `custom`
          - **type: keyword** (`type: keyword`)
            - `type` (enum)
              Values: `keyword`
            - `version` (string)
            - `buffer_size` (number · default: 256)
          - **type: letter** (`type: letter`)
            - `type` (enum)
              Values: `letter`
            - `version` (string)
          - **type: lowercase** (`type: lowercase`)
            - `type` (enum)
              Values: `lowercase`
            - `version` (string)
          - **type: ngram** (`type: ngram`)
            - `type` (enum)
              Values: `ngram`
            - `version` (string)
            - `custom_token_chars` (string)
            - `max_gram` (number)
            - `min_gram` (number)
            - `token_chars` (enum[] · default: [])
              Values: `letter`, `digit`, `whitespace`, `punctuation`, `symbol`, `custom`
          - **type: path_hierarchy** (`type: path_hierarchy`)
            - `type` (enum)
              Values: `path_hierarchy`
            - `version` (string)
            - `buffer_size` (number | string)
            - `delimiter` (string)
            - `replacement` (string)
            - `reverse` (boolean | string)
            - `skip` (number | string)
          - **type: pattern** (`type: pattern`)
            - `type` (enum)
              Values: `pattern`
            - `version` (string)
            - `flags` (string)
            - `group` (number)
            - `pattern` (string)
          - **type: simple_pattern** (`type: simple_pattern`)
            - `type` (enum)
              Values: `simple_pattern`
            - `version` (string)
            - `pattern` (string)
          - **type: simple_pattern_split** (`type: simple_pattern_split`)
            - `type` (enum)
              Values: `simple_pattern_split`
            - `version` (string)
            - `pattern` (string)
          - **type: standard** (`type: standard`)
            - `type` (enum)
              Values: `standard`
            - `version` (string)
            - `max_token_length` (number)
          - **type: thai** (`type: thai`)
            - `type` (enum)
              Values: `thai`
            - `version` (string)
          - **type: uax_url_email** (`type: uax_url_email`)
            - `type` (enum)
              Values: `uax_url_email`
            - `version` (string)
            - `max_token_length` (number)
          - **type: whitespace** (`type: whitespace`)
            - `type` (enum)
              Values: `whitespace`
            - `version` (string)
            - `max_token_length` (number)
          - **type: icu_tokenizer** (`type: icu_tokenizer`)
            - `type` (enum)
              Values: `icu_tokenizer`
            - `version` (string)
            - `rule_files` (string)
          - **type: kuromoji_tokenizer** (`type: kuromoji_tokenizer`)
            - `type` (enum)
              Values: `kuromoji_tokenizer`
            - `version` (string)
            - `discard_punctuation` (boolean)
            - `mode` (enum)
              Values: `normal`, `search`, `extended`
            - `nbest_cost` (number)
            - `nbest_examples` (string)
            - `user_dictionary` (string)
            - `user_dictionary_rules` (string[])
            - `discard_compound_token` (boolean)
          - **type: nori_tokenizer** (`type: nori_tokenizer`)
            - `type` (enum)
              Values: `nori_tokenizer`
            - `version` (string)
            - `decompound_mode` (enum)
              Values: `discard`, `none`, `mixed`
            - `discard_punctuation` (boolean)
            - `user_dictionary` (string)
            - `user_dictionary_rules` (string[])
    - `settings` (object) — recursive
      Same fields as `settings` in `data_streams`
    - `time_series` (object)
      - `end_time` (union oneOf)
        One of: `string` or `number`
      - `start_time` (union oneOf)
        One of: `string` or `number`
      - `temporality_field` (string)
        The name of the field that stores the temporality of a metric.
The referenced field must be a `keyword` dimension field; if the setting is unset or the
field is missing or invalid, the metric temporality resolves to null.
    - `queries` (object)
      - `cache` (object)
        - `enabled` (boolean)
    - `requests` (object)
      - `cache` (object)
        - `enable` (boolean | string · default: true)
          Whether the shard request cache is enabled for the index.
This setting is dynamic and can be updated on an existing index.
    - `similarity` (map string to oneOf)
      Configure custom similarity settings to customize how search results are scored.
      Map values (union oneOf)
      One of:
      - **type: BM25** (`type: BM25`)
        - `type` (enum)
          Values: `BM25`
        - `b` (number)
        - `discount_overlaps` (boolean)
        - `k1` (number)
      - **type: boolean** (`type: boolean`)
        - `type` (enum)
          Values: `boolean`
      - **type: DFI** (`type: DFI`)
        - `type` (enum)
          Values: `DFI`
        - `independence_measure` (enum)
          Values: `standardized`, `saturated`, `chisquared`
      - **type: DFR** (`type: DFR`)
        - `type` (enum)
          Values: `DFR`
        - `after_effect` (enum)
          Values: `no`, `b`, `l`
        - `basic_model` (enum)
          Values: `be`, `d`, `g`, `if`, `in`, `ine`, `p`
        - `normalization` (enum)
          Values: `no`, `h1`, `h2`, `h3`, `z`
      - **type: IB** (`type: IB`)
        - `type` (enum)
          Values: `IB`
        - `distribution` (enum)
          Values: `ll`, `spl`
        - `lambda` (enum)
          Values: `df`, `ttf`
        - `normalization` (enum)
          Values: `no`, `h1`, `h2`, `h3`, `z`
      - **type: LMDirichlet** (`type: LMDirichlet`)
        - `type` (enum)
          Values: `LMDirichlet`
        - `mu` (number)
      - **type: LMJelinekMercer** (`type: LMJelinekMercer`)
        - `type` (enum)
          Values: `LMJelinekMercer`
        - `lambda` (number)
      - **type: scripted** (`type: scripted`)
        - `type` (enum)
          Values: `scripted`
        - `script` (string)
        - `weight_script` (string)
    - `mapping` (object)
      Enable or disable dynamic mapping for an index.
      - `coerce` (boolean)
      - `total_fields` (object)
        - `limit` (number | string · default: 1000)
          The maximum number of fields in an index. Field and object mappings, as well as field aliases count towards this limit.
The limit is in place to prevent mappings and searches from becoming too large. Higher values can lead to performance
degradations and memory issues, especially in clusters with a high load or few resources.
        - `ignore_dynamic_beyond_limit` (boolean | string · default: false)
          This setting determines what happens when a dynamically mapped field would exceed the total fields limit. When set
to false (the default), the index request of the document that tries to add a dynamic field to the mapping will fail
with the message Limit of total fields [X] has been exceeded. When set to true, the index request will not fail.
Instead, fields that would exceed the limit are not added to the mapping, similar to dynamic: false.
The fields that were not added to the mapping will be added to the _ignored field.
      - `depth` (object)
        - `limit` (number · default: 20)
          The maximum depth for a field, which is measured as the number of inner objects. For instance, if all fields are defined
at the root object level, then the depth is 1. If there is one object mapping, then the depth is 2, etc.
      - `nested_fields` (object)
        - `limit` (number · default: 50)
          The maximum number of distinct nested mappings in an index. The nested type should only be used in special cases, when
arrays of objects need to be queried independently of each other. To safeguard against poorly designed mappings, this
setting limits the number of unique nested types per index.
      - `nested_objects` (object)
        - `limit` (number · default: 10000)
          The maximum number of nested JSON objects that a single document can contain across all nested types. This limit helps
to prevent out of memory errors when a document contains too many nested objects.
      - `field_name_length` (object)
        - `limit` (number)
          Setting for the maximum length of a field name. This setting isn’t really something that addresses mappings explosion but
might still be useful if you want to limit the field length. It usually shouldn’t be necessary to set this setting. The
default is okay unless a user starts to add a huge number of fields with really long names. Default is `Long.MAX_VALUE` (no limit).
      - `dimension_fields` (object)
        - `limit` (number)
          [preview] This functionality is in technical preview and may be changed or removed in a future release.
Elastic will work to fix any issues, but features in technical preview are not subject to the support SLA of official GA features.
      - `source` (object)
        - `mode` (enum)
          Values: `disabled`, `stored`, `synthetic`
      - `ignore_malformed` (boolean | string)
    - `indexing.slowlog` (object)
      - `level` (string)
      - `source` (number)
      - `reformat` (boolean)
      - `threshold` (object)
        - `index` (object)
          The indexing slow log, similar in functionality to the search slow log. The log file name ends with `_index_indexing_slowlog.json`.
Log and the thresholds are configured in the same way as the search slowlog.
          - `warn` (union oneOf)
            Values: `-1`, `0`
          - `info` (union oneOf)
            Values: `-1`, `0`
          - `debug` (union oneOf)
            Values: `-1`, `0`
          - `trace` (union oneOf)
            Values: `-1`, `0`
    - `indexing_pressure` (object)
      Configure indexing back pressure limits.
      - `memory` (object)
        - `limit` (number)
          Number of outstanding bytes that may be consumed by indexing requests. When this limit is reached or exceeded,
the node will reject new coordinating and primary operations. When replica operations consume 1.5x this limit,
the node will reject new replica operations. Defaults to 10% of the heap.
    - `store` (object)
      The store module allows you to control how index data is stored and accessed on disk.
      - `type` (union anyOf)
        

Supported values include:
  - `fs`: Default file system implementation. This will pick the best implementation depending on the operating environment, which
is currently hybridfs on all supported systems but is subject to change.
  - `niofs`: The NIO FS type stores the shard index on the file system (maps to Lucene NIOFSDirectory) using NIO. It allows multiple
threads to read from the same file concurrently. It is not recommended on Windows because of a bug in the SUN Java
implementation and disables some optimizations for heap memory usage.
  - `mmapfs`: The MMap FS type stores the shard index on the file system (maps to Lucene MMapDirectory) by mapping a file into
memory (mmap). Memory mapping uses up a portion of the virtual memory address space in your process equal to the size
of the file being mapped. Before using this class, be sure you have allowed plenty of virtual address space.
  - `hybridfs`: The hybridfs type is a hybrid of niofs and mmapfs, which chooses the best file system type for each type of file
based on the read access pattern. Currently only the Lucene term dictionary, norms and doc values files are memory
mapped. All other files are opened using Lucene NIOFSDirectory. Similarly to mmapfs be sure you have allowed
plenty of virtual address space.
        Values: `fs`, `niofs`, `mmapfs`, `hybridfs`
      - `allow_mmap` (boolean)
        You can restrict the use of the mmapfs and the related hybridfs store type via the setting node.store.allow_mmap.
This is a boolean setting indicating whether or not memory-mapping is allowed. The default is to allow it. This
setting is useful, for example, if you are in an environment where you can not control the ability to create a lot
of memory maps so you need disable the ability to use memory-mapping.
      - `stats_refresh_interval` (union oneOf)
        How often store statistics are refreshed
        Values: `-1`, `0`
  - `effective_settings` (object)
    The settings specific to this data stream merged with the settings from its template. These `effective_settings`
are the settings that will be used when a new index is created for this data stream.
    Same fields as `settings` in `data_streams`
## Code examples

#### Console

```console
GET /_data_stream/my-data-stream/_settings
```

#### JavaScript

```javascript
const response = await client.indices.getDataStreamSettings({
  name: "my-data-stream",
});
```

#### Python

```python
resp = client.indices.get_data_stream_settings(
    name="my-data-stream",
)
```

#### curl

```curl
curl -X GET "$ELASTICSEARCH_URL/_data_stream/my-data-stream/_settings" \
  -H "Authorization: ApiKey $ELASTIC_API_KEY"
```

#### Java

```java
client.indices().getDataStreamSettings(g -> g
    .name("my-data-stream")
);
```

#### C#

```c#
[...]
